searchData={"items":[{"type":"module","title":"filezcache","doc":"Filezcache api, insert, lookup, stream and delete cached files.","ref":"filezcache.html"},{"type":"function","title":"filezcache.access/1","doc":"Save access time as a information in the datastore.","ref":"filezcache.html#access/1"},{"type":"function","title":"filezcache.append_stream/2","doc":"Append to existed stream.","ref":"filezcache.html#append_stream/2"},{"type":"function","title":"filezcache.checksum/1","doc":"Return checksum.","ref":"filezcache.html#checksum/1"},{"type":"function","title":"filezcache.data_dir/0","doc":"Return the directory for the storage of the cached files.","ref":"filezcache.html#data_dir/0"},{"type":"function","title":"filezcache.delete/1","doc":"Delete data item for the storage.","ref":"filezcache.html#delete/1"},{"type":"function","title":"filezcache.finish_stream/1","doc":"Finish existed stream.","ref":"filezcache.html#finish_stream/1"},{"type":"function","title":"filezcache.insert/2","doc":"Equivalent to insert(Key, Bin, []) . Insert binary value.","ref":"filezcache.html#insert/2"},{"type":"function","title":"filezcache.insert/3","doc":"Insert binary value and options.","ref":"filezcache.html#insert/3"},{"type":"function","title":"filezcache.insert_file/2","doc":"Equivalent to insert_file(Key, FilePath, []) . Insert file.","ref":"filezcache.html#insert_file/2"},{"type":"function","title":"filezcache.insert_file/3","doc":"Insert file and options.","ref":"filezcache.html#insert_file/3"},{"type":"function","title":"filezcache.insert_stream/1","doc":"Equivalent to insert_stream(Key, undefined, []) . Insert stream.","ref":"filezcache.html#insert_stream/1"},{"type":"function","title":"filezcache.insert_stream/3","doc":"Insert stream.","ref":"filezcache.html#insert_stream/3"},{"type":"function","title":"filezcache.insert_stream/4","doc":"Insert stream.","ref":"filezcache.html#insert_stream/4"},{"type":"function","title":"filezcache.insert_tmpfile/2","doc":"Equivalent to insert_tmpfile(Key, FilePath, []) . Insert temporary file.","ref":"filezcache.html#insert_tmpfile/2"},{"type":"function","title":"filezcache.insert_tmpfile/3","doc":"Insert temporary file and options.","ref":"filezcache.html#insert_tmpfile/3"},{"type":"function","title":"filezcache.insert_wait/1","doc":null,"ref":"filezcache.html#insert_wait/1"},{"type":"function","title":"filezcache.journal_dir/0","doc":"Return the directory for the storage of the log/journal files.","ref":"filezcache.html#journal_dir/0"},{"type":"function","title":"filezcache.locate_monitor/1","doc":"Try to find monitor by Key.","ref":"filezcache.html#locate_monitor/1"},{"type":"function","title":"filezcache.lookup/1","doc":"Lookup datastore element by Key. Either returns the file in the filecache or a device pid to read from. The file is returned if the cache entry is complete, the device is returned if the cache entry is being written to. Read the device using file:read(Pid, Length).","ref":"filezcache.html#lookup/1"},{"type":"function","title":"filezcache.lookup/2","doc":"Lookup datastore element by Pid or Key and options.","ref":"filezcache.html#lookup/2"},{"type":"function","title":"filezcache.lookup_file/1","doc":"Lookup File by Key.","ref":"filezcache.html#lookup_file/1"},{"type":"function","title":"filezcache.lookup_file/2","doc":"Lookup Pid and options.","ref":"filezcache.html#lookup_file/2"},{"type":"function","title":"filezcache.stats/0","doc":"Return data storade information.","ref":"filezcache.html#stats/0"},{"type":"function","title":"filezcache.where/1","doc":"Check existence of Key in the data storage.","ref":"filezcache.html#where/1"},{"type":"module","title":"filezcache_lru","doc":"Erlang LRU cache/Queue with deletion by key. Motivation: For many purposes we need FIFO of elements with fast-enough deletion from the middle. This FIFO also can be used as LRU cache (Least Recently Used Cache).","ref":"filezcache_lru.html"},{"type":"function","title":"filezcache_lru.add/3","doc":"Add new element to cache with defined key. Complexity: O(log(N))","ref":"filezcache_lru.html#add/3"},{"type":"function","title":"filezcache_lru.empty/1","doc":"Check if queue is empty. Complexity: O(1)","ref":"filezcache_lru.html#empty/1"},{"type":"function","title":"filezcache_lru.has_key/2","doc":"Check if cache has element with key. Complexity: O(1)","ref":"filezcache_lru.html#has_key/2"},{"type":"function","title":"filezcache_lru.lookup_and_update/2","doc":"Lookup and update cache (LRU function). Complexity: O(log(N))","ref":"filezcache_lru.html#lookup_and_update/2"},{"type":"function","title":"filezcache_lru.new/0","doc":"Create new unlimited cache. Complexity: O(1)","ref":"filezcache_lru.html#new/0"},{"type":"function","title":"filezcache_lru.new/1","doc":"Create new limited cache with defined max size Complexity: O(1)","ref":"filezcache_lru.html#new/1"},{"type":"function","title":"filezcache_lru.pop/1","doc":"Pop element from head. Complexity: O(log(N))","ref":"filezcache_lru.html#pop/1"},{"type":"function","title":"filezcache_lru.push/3","doc":"Push element to queue tail. Complexity: O(log(N))","ref":"filezcache_lru.html#push/3"},{"type":"function","title":"filezcache_lru.size/1","doc":"Get number of elements in the LRU cache. Complexity: O(1)","ref":"filezcache_lru.html#size/1"},{"type":"function","title":"filezcache_lru.take/2","doc":"Take element from queue by key Complexity: O(log(N))","ref":"filezcache_lru.html#take/2"},{"type":"type","title":"filezcache_lru.key/0","doc":null,"ref":"filezcache_lru.html#t:key/0"},{"type":"type","title":"filezcache_lru.lru/0","doc":null,"ref":"filezcache_lru.html#t:lru/0"},{"type":"type","title":"filezcache_lru.value/0","doc":null,"ref":"filezcache_lru.html#t:value/0"},{"type":"extras","title":"README","doc":"[![Hex.pm version][hexpm version]][hexpm]\n[![Hex.pm Downloads][hexpm downloads]][hexpm]\n[![Hex.pm Documentation][hexdocs documentation]][hexdocs]\n[![Erlang Versions][erlang version badge]][gh]\n[![License][license]](https://www.apache.org/licenses/LICENSE-2.0)\n\n\nFilezcache - cache s3 and other files on disk\n=============================================\n\nThis is a file caching system optimized for use with cowmachine\nbut can also be used with other services.\n\nIt has some unique properties:\n\n * Lookups return file references (if possible) which can be used with sendfile\n * Cached files can be streamed to requestors while they are being filled\n * On startup the cache is repopulated with existing files\n * Lookups return data formats directly useable for cowmachine serving\n\nThe system uses the file system to store files and a disk log. The files are stored\nin `priv/data/` and the disk log in `priv/journal`.\n\nThe disk log is used to rebuild the cache after a start. Files present on disk but\nnot mentioned in the disk log are deleted.\n\nExample\n-------\n\n    $ ./rebar3 shell\n    ===> Verifying dependencies...\n    ===> Analyzing applications...\n    ===> Compiling filezcache\n    Erlang/OTP 26 [erts-14.2.1] [source] [64-bit] [smp:10:10] [ds:10:10:10] [async-threads:1] [jit]\n    Eshell V14.2.1 (press Ctrl+G to abort, type help(). for help)\n    1> application:ensure_all_started(filezcache).\n    ok\n    2> filezcache:lookup(mykey).\n    {error, enoent}\n    3> filezcache:insert(mykey, <<\"foobar\">>).\n    {ok,<0.173.0>}.\n    4> filezcache:lookup(mykey).\n    {ok,{file,6,\"priv/data/4J0I2F06043V5P0V603D4O4I6L1J5M1B4I5Y2B2C606W28131H164Z421M4X6221\"}}\n    5> filezcache:insert(mykey, <<>>).\n    {error,{already_started,<0.173.0>}}\n    6> filezcache:delete(mykey).\n    ok\n\n\nConfiguration keys\n------------------\n\n * `max_bytes` Maximum size of the cache in bytes, defaults to 10GiB (10737418240 bytes)\n * `journal_dir` Directory for the disk log, defaults to `priv/journal`\n * `data_dir` Directory for the cached files, defaults to `priv/data`\n\nTODO\n----\n\nThere are some known issues that need to be resolved:\n\n * Add timeouts to `filezcache_entry` states `wait_for_data` and `streaming`\n\n<!-- Badges -->\n[hexpm]: https://hex.pm/packages/filezcache\n[hexpm version]: https://img.shields.io/hexpm/v/filezcache.svg?style=flat-curcle \"Hex version\"\n[hexpm downloads]: https://img.shields.io/hexpm/dt/filezcache.svg?style=flat-curcle\n[hexdocs documentation]: https://img.shields.io/badge/hex-docs-purple.svg?style=flat-curcle\n[hexdocs]: https://hexdocs.pm/filezcache\n[gh]: https://github.com/mworrell/filezcache/actions/workflows/test.yaml\n[erlang version badge]: https://img.shields.io/badge/Supported%20Erlang%2FOTP-22.3%20to%2026-blue.svg?style=flat-curcle\n[license]: https://img.shields.io/badge/License-Apache_2.0-blue.svg?logo=apache&logoColor=red \"Apache 2.0\"","ref":"readme.html"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS","ref":"license.html"},{"type":"extras","title":"LICENSE-MIT","doc":"src/filezcache_lru is licensed under the MIT license.\n-----------------------------------------------------\n\nMIT License\n\nCopyright (c) 2018 Dmitry Poroh\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license-mit.html"}],"content_type":"text/plain","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}